Difference between revisions of "Draft PathArray/de"

From FreeCAD Documentation
Jump to navigation Jump to search
 
(45 intermediate revisions by 4 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
{{Docnav/de/de
+
{{Docnav/de
|[[Draft_LinkArray|Verknüpfe Anordnung]]
+
|[[Draft_LinkArray/de|Verknüpfe Anordnung]]
|[[Draft_PathLinkArray|Bahn VerknüpfeAnordnung]]|[[Draft_Module|Draft]]
+
|[[Draft_PathLinkArray/de|Pfad VerknüpfeAnordnung]]
 +
|[[Draft_Module/de|Entwurf]]
 
|IconL=Draft_LinkArray.svg
 
|IconL=Draft_LinkArray.svg
 
|IconC=Workbench_Draft.svg
 
|IconC=Workbench_Draft.svg
Line 9: Line 10:
  
 
{{GuiCommand/de
 
{{GuiCommand/de
|Name=Draft BahnAnordnung
+
|Name=Draft PathArray
|MenuLocation=Entwurf BahnAnordnung
+
|Name/de=Entwurf PfadAnordnung
 +
|MenuLocation=Modifikation → Anordnung Werkzeuge Pfad Anordnung
 
|Workbenches=[[Draft Module/de|Entwurf]], [[Arch Module/de|Arch]]
 
|Workbenches=[[Draft Module/de|Entwurf]], [[Arch Module/de|Arch]]
|SeeAlso=[[Draft PathLinkArray/de|Entwurf BahnVerknüpfeAnordnung]], [[Draft Array/de|Entwurf Anordnung]], [[Draft LinkArray/de|Entwurf VerknüpfeAnordnung]], [[Draft PointArray/de|Entwurf PunktAnordnung]]
+
|SeeAlso=[[Draft_OrthoArray/de|Entwurf OrthoAnordnung]], [[Draft_PolarArray/de|Entwurf PolarArray]], [[Draft_CircularArray/de|Entwurf CircularArray]], [[Draft PathLinkArray/de|Entwurf PfadVerknüpfeAnordnung]], [[Draft PointArray/de|Entwurf PunktAnordnung]], [[Draft_Clone/de|Entwurf Klonen]]
 +
|Version=0.14
 
}}
 
}}
  
 
==Beschreibung==
 
==Beschreibung==
  
Das BahnAnordnungswWerkzeug platziert Kopien einer ausgewählten Form entlang einer ausgewählten Bahn, die aus einem [[Draft Wire|Entwurf Draht]], einem [[Draft BSpline|Entwurf BSpline]] und ähnlichen Kanten bestehen können.
+
Das {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft PathArray/de|Entwurf PfadAnordnung]]}} Werkzeug platziert Kopien einer ausgewählten Form entlang eines ausgewählten Pfades, der ein [[Draft Wire/de|Entwurf Draht]], ein [[Draft BSpline|Entwurf BSpline]] und ähnliche Kanten sein kann.
  
Das BahnAnordnungswerkzeug kann auf 2D Formen verwendet werden, die mit der [[Draft Workbench/de|Entwurf Arbeitsbereich]] erstellt wurden, aber auch auf vielen Arten von 3D Objekten, wie sie mit der [[Part Workbench/de|Part Arbeitsbereich]], [[PartDesign Workbench/de|PartDesign Arbeitsbereich]] oder [[Arch Workbench/de|Arch Arbeitsbereich]]en erstellt wurden.  
+
Das PfadAnordnungswerkzeug kann auf jedes Objekt verwendet werden das eine [[Part_TopoShape/de|Part TopoForm]] hat, bedeutet 2D Formen, die mit dem [[Draft Workbench/de|Entwurf Arbeitsbereich]] erstellt wurden, aber auch 3D Festkörper, die mit anderen Arbeitsbereichen erstellt wurden, z.B. [[Part Workbench/de|Part Arbeitsbereich]], [[PartDesign Workbench/de|PartDesign Arbeitsbereich]] oder [[Arch Workbench/de|Arch Arbeitsbereich]].
  
Um Kopien in einem orthogonalen Anordnung zu positionieren, verwende [[Draft Array/de|Entwurf Anordnung]]; um Kopien an bestimmten Punkten zu positionieren, verwende [[Draft PointArray/de|Entwurf PunktAnordnung]]; um Kopien oder Klone zu erstellen und diese manuell zu platzieren, verwende [[Draft Move/de|Entwurf Bewegen]], [[Draft Rotate/de|Entwurf Drehung]] und [[Draft Clone/de|Entwurf  Klon]].
+
* Um rechtwinklig, polare oder kreisförmige Anordnungen zu erstellen, verwende die entsprechende  {{Button|[[File:Draft_OrthoArray.svg|16px]] [[Draft_OrthoArray/de|OrthoAnordnung]]}}, {{Button|[[File:Draft_PolarArray.svg|16px]] [[Draft_PolarArray/de|PolarAnordnung]]}}, oder {{Button|[[File:Draft_CircularArray.svg|16px]] [[Draft_CircularArray/de|CircularAnordnung]]}}s Werkzeuge.
 +
* Um [[App_Link/de|Anwendungsverknüpfungs]] Kopien entlang eines Pfades zu positionieren, verwende {{Button|[[File:Draft_PathLinkArray.svg|16px]] [[Draft_PathLinkArray/de|PfadVerknüpfeAnordnung]]}}.
 +
* Um Kopien an festgelegten Punkten zu positionieren, verwende {{Button|[[File:Draft_PointArray.svg|16px]] [[Draft_PointArray/de|PunktAnordnung]]}} oder {{Button|[[File:Draft_PointLinkArray.svg|16px]] [[Draft_PointLinkArray/de|PunktVerknüpfeAnordnung]]}}.
 +
* Um Kopien zu erstellen und manuell zu platzieren, verwende {{Button|[[File:Draft_Move.svg|16px]] [[Draft_Move/de|Bewegen]]}} oder {{Button|[[File:Draft_Rotate.svg|16px]] [[Draft_Rotate/de|Drehen]]}}.
 +
* Um exakte Kopien zu erstellen und diese manuell zu platzieren oder zu skalieren, verwende {{Button|[[File:Draft_Clone.svg|16px]] [[Draft_Clone/de|Klonen]]}} oder {{Button|[[File:Std_LinkMake.svg|16px]] [[Std_LinkMake/de|Std MacheVerknüpfung]]}}.
  
 
[[Image:Draft_PathArray_Example.png|400px]]
 
[[Image:Draft_PathArray_Example.png|400px]]
{{Caption|Objekt entlang einer Bahn angeordnet}}
+
{{Caption|Objekt entlang eines Pfades angeordnet}}
  
==Kurzanleitung==
+
==Anwendung==
  
# Wähle ein Objekt aus, das du verteilen möchten.
+
# Wähle das Objekt aus, das du verteilen möchtest.
# Wähle ein Pfadobjekt oder einige Kanten aus, entlang derer das Objekt verteilt werden soll.
+
# Wähle das Pfadobjekt oder die Kanten, entlang derer das Objekt verteilt werden soll.
# Drücke die Taste {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft PathArray/de|Entwurf PfadAnordnung]]}}.
+
# Drücke die {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft_PathArray/de|PfadAnordnung]]}} Schaltfläche.
 
# Das Anordnungsobjekt wird sofort erzeugt. Du musst die Eigenschaften der Anordnung ändern, um die Anzahl und Richtung der erstellten Kopien zu ändern.
 
# Das Anordnungsobjekt wird sofort erzeugt. Du musst die Eigenschaften der Anordnung ändern, um die Anzahl und Richtung der erstellten Kopien zu ändern.
  
Jedes Element in der Anordnung ist ein exakter Klon des ursprünglichen Objekts, aber die gesamte Anordnung wird in Bezug auf Eigenschaften und Aussehen als eine Einheit betrachtet.  
+
Jedes Element in der Anordnung ist ein exakter Klon des ursprünglichen Objekts, aber die gesamte Anordnung wird in Bezug auf Eigenschaften und Aussehen als eine Einheit betrachtet.
  
Das Basisobjekt sollte um den Ursprung zentriert sein, auch wenn der Pfad irgendwo anders beginnt.
+
{{Emphasis|Hinweis:}} wenn das {{PropertyData|Basis}} Objekt nicht korrekt im Pfad positioniert zu sein scheint, prüfe, ob seine {{PropertyData|Platzierung}} im Ursprung {{Value|(0,0,0)}} liegt.
 +
Bestimmte Objekte können überall im 3D Raum platziert werden wenn mit dem {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft_PathArray/de|PfadAnordnungs]]}} Werkzeug verwendet, jedoch müssen andere am Ursprung sein, insbesondere solche, die unter Verwendung von {{Button|[[File:Part_Extrude.svg|16px]] [[Part_Extrude/de|Part Extrudieren]]}} mit einem 2D Profil wie eine {{Button|[[File:Sketcher_NewSketch.svg|16px]] [[Sketch/de|Skizze]]}} erstellt wurden.
  
 
==Optionen==
 
==Optionen==
Line 43: Line 51:
 
==Eigenschaften==
 
==Eigenschaften==
  
* {{PropertyData|Base}}: specifies the object to duplicate in the path.
+
Eine [[Draft_PathArray/de|PfadAnordnung]] wird abgeleitet von einer [[Part_Feature/de|Part Formelement]] ({{incode|Part::Feature}} Klasse), daher teilt sie alle Eigenschaften der letzteren. Zusätzlich zu den in [[Part_Feature/de|Part Formelement]] beschriebenen Eigenschaften hat die PfadAnordnung die folgenden Eigenschaften im [[property_editor/de|Eigenschaftseditor]] .
* {{PropertyData|PathObj}}: specifies the path object.
 
* {{PropertyData|PathSubs}}: specifies the sub-elements (edges) of the path object. This property does not yet appear in the [[property editor|property editor]].
 
* {{PropertyData|Count}}: specifies the number of copies of the base object.
 
* {{PropertyData|Align}}: if it is {{TRUE}} the copies are aligned to the path; otherwise they are left in their default orientation.
 
:{{Emphasis|Note:}} in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
 
* {{PropertyData|Xlate}}: specifies a translation vector (x, y, z) to displace each copy along the path.
 
:{{Emphasis|Note:}} when {{PropertyData|Align}} is {{TRUE}}, the vector is relative to the local tangent, normal or binormal coordinates; otherwise the vector is relative to the global coordinates.
 
  
==Scripting==
+
<div class="mw-translate-fuzzy">
{{Emphasis|Siehe auch:}} [[Draft API/de|Draft API]] und [[FreeCAD Scripting Basics/de|FreeCAD Scripting Grundlagen]].
+
{{TitleProperty|Ausrichtung}}
 +
* {{PropertyData|Ausrichten|Bool}}: wenn es {{TRUE}} ist, werden die Kopien am Pfad ausgerichtet; andernfalls werden sie in ihrer Standardausrichtung belassen.
 +
:{{Emphasis|Hinweis:}} in bestimmten Fällen wird die Form flach erscheinen, in Wirklichkeit kann sie sich im 3D Raum bewegt haben, ändere also statt einer flachen Ansicht die Ansicht auf axonometrisch.
 +
* {{PropertyData|Ausrichtungsmodus|Aufzählung}}: drei Modi, {{Value|Original}}, {{Value|Frenet}}, {{Value|Tangent}}.
 +
* {{PropertyDataZusätzliche Translation|VektorAbstand}}: zusätzlicher Verschiebungsvektor {{Value|(x, y, z)}}, der auf jede Kopie entlang des Pfades angewendet wird. Dies ist nützlich, um kleine Anpassungen in der Position der Kopien vorzunehmen, z.B. wenn ihr Referenzpunkt nicht mit dem Mittelpunkt ihrer Form übereinstimmt.
 +
* {{PropertyData|Force Vertical|Bool}}: Wenn er {{TRUE}} ist, wird der Wert von {{PropertyData|Vertikal Vektor}} als lokale Z Richtung verwendet, wenn {{PropertyData|Ausrichtungsmodus}} {{Value|Original}} oder {{Value|Tangente}} ist. {{Version|0.19}}
 +
* {{PropertyData|Tangentenvektor|Vektor}}: die Standardeinstellung ist {{Value|(1, 0, 0)}}; Ausrichtungseinheitsvektor, der verwendet wird, wenn  {{PropertyData|Ausrichtungsmodus}} {{Value|Tangente}} ist. {{Version|0.19}}
 +
* {{PropertyData|Vertikal Vektor|Vektor}}}: Standardeinstellung ist {{Value|(0, 0, 1)}}; Einheitsvektor der lokalen Z Richtung, der verwendet wird, wenn {{PropertyData|VertiKal Vektor}}  {{TRUE}} ist. {{Version|0.19}}
 +
</div>
 +
 
 +
{{TitleProperty|Objects}}
 +
* {{PropertyData|Base|LinkGlobal}}: specifies the object to duplicate in the path.
 +
* {{PropertyData|Count|Integer}}: specifies the number of copies to create in the path.
 +
* {{PropertyData|Path Object|LinkGlobal}}: specifies the object along which the copies will be distributed. It must contain {{Value|'Edges'}} in its [[Part_TopoShape|Part TopoShape]]; for example, it could be a {{Button|[[File:Draft_Wire.svg|16px]] [[Draft_Wire|Wire]]}} or {{Button|[[File:Draft_BSpline.svg|16px]] [[Draft_BSpline|BSpline]]}}.
 +
* {{PropertyData|Path Subelements|LinkSubListGlobal}}: specifies the sub-elements (edges) of the {{PropertyData|Path Object}} on which the copies will be created. The copies will be created only on these edges. If this property is empty, the copies will be distributed on the entire {{PropertyData|Path Object}}.
 +
 
 +
==Skripten==
 +
{{Emphasis|Siehe auch:}} [[Draft API/de|Draft API]] und [[FreeCAD Scripting Basics/de|FreeCAD Grundlagen Skripten]].
 +
 
 +
Das Pfadanordnungswerkzeug kann in [[macros/de|Makros]] und von der [[Python/de|Python]] Konsole aus mit folgender Funktion verwendet werden:
  
The PathArray tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
+
Alter Aufruf:
 
{{Code|code=
 
{{Code|code=
PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
+
path_array = makePathArray(base_object, path_object, count, xlate=None, align=False, pathobjsubs=[])
 
}}
 
}}
  
* Creates a {{incode|PathArray}} object from the {{incode|baseobject}}, by placing as many as {{incode|count}} copies along {{incode|pathobject}}.
+
Neuer Aufruf:
** If {{incode|pathobjsubs}} is given, it is a list of sub-objects of {{incode|pathobject}}, and the copies are created along this shorter path.
+
{{Code|code=
* If {{incode|xlate}} is given, it is a {{incode|FreeCAD.Vector}} that indicates an additional displacement to move the base point of the copies.
+
path_array = make_path_array(base_object, path_object,
* If {{incode|align}} is {{incode|True}} the copies are aligned to the tangent, normal or binormal of the {{incode|pathobject}} at the point where the copy is placed.
+
                            count=4, extra=App.Vector(0, 0, 0), subelements=None,
 +
                            align=False, align_mode="Original", tan_vector=App.Vector(1, 0, 0),
 +
                            force_vertical=False, vertical_vector=App.Vector(0, 0, 1),
 +
                            use_link=True):
 +
}}
 +
 
 +
<div class="mw-translate-fuzzy">
 +
* Erstellt eine {{incode|Pfad Anordnungs}} Objekt aus dem {{incode|baseobject}}, indem bis zu {{incode|Anzahl}} Kopien entlang des  {{incode/de|Pfadobjekt}} platziert werden.
 +
** Wenn {{incode/de|Pfadobjektunter}} angegeben wird, handelt es sich um eine Liste von Unterobjekten von {{incode/de|Pfadobjekt}}, und die Kopien werden entlang dieses kürzeren Pfades erstellt.
 +
* Wenn {{incode|xlate}} angegeben wird, handelt es sich um einen {{incode|FreeCAD.Vector}}, der eine zusätzliche Verschiebung anzeigt, um den Basispunkt der Kopien zu verschieben.
 +
* Wenn {{incode|align}} {{incode|True}} ist, werden die Kopien an der Tangente, der Normalen oder dem Binormalen des {{incode/de|Pfadobjekt}} an dem Punkt ausgerichtet, an dem die Kopie platziert wird.
 +
</div>
  
 
Beispiel:  
 
Beispiel:  
 
{{Code|code=
 
{{Code|code=
import FreeCAD,Draft
+
import FreeCAD as App
 +
import Draft
 +
 
 +
doc = App.newDocument()
  
p1 = FreeCAD.Vector(500, -1000, 0)
+
p1 = App.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
+
p2 = App.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
+
p3 = App.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
+
p4 = App.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
+
spline = Draft.make_bspline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)
+
obj = Draft.make_polygon(3, 500)
  
PathArray = Draft.makePathArray(object, spline, 6)
+
path_array = Draft.make_path_array(obj, spline, 6)
 +
doc.recompute()
 +
 
 +
wire = Draft.make_wire([p1, -p2, -p3, -p4])
 +
path_array2 = Draft.make_path_array(obj, wire, count=3, extra=App.Vector(0, -500, 0), subelements=["Edge2", "Edge3"], align=True, force_vertical=True)
 +
doc.recompute()
 
}}
 
}}
  
 
==Technische Erklärung für die Ausrichteigenschaft==
 
==Technische Erklärung für die Ausrichteigenschaft==
 +
Wenn {{PropertyData|Ausrichten}} {{FALSE}} ist, ist die Platzierung der kopierten Formen leicht zu verstehen; sie werden einfach an eine andere Position in ihrer ursprünglichen Ausrichtung verschoben.
 
[[Image:patharray_NoAlign.png|600px|left|Align false]]
 
[[Image:patharray_NoAlign.png|600px|left|Align false]]
 
{{clear}}
 
{{clear}}
 
{{Caption|Objekt, das entlang eines geschlossenen Pfades in der ursprünglichen Ausrichtung angeordnet ist.}}
 
{{Caption|Objekt, das entlang eines geschlossenen Pfades in der ursprünglichen Ausrichtung angeordnet ist.}}
  
When {{PropertyData|Align}} is {{TRUE}}, the positioning of the shapes becomes a bit more complex:
+
Wenn {{PropertyData|Align}} {{TRUE}} ist, wird die Positionierung der Formen etwas komplexer:
# First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
+
# Zuerst werden Frenet Koordinatensysteme auf dem Pfad aufgebaut: X ist tangential, Z ist normal, Y ist binormal.
# Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.
+
# Dann wird das Originalobjekt in jedes pfadbegleitende Koordinatensystem kopiert, so dass der globale Ursprung mit dem Ursprung des pfadbegleitenden Koordinatensystems übereinstimmt.
 
[[Image:patharray alignment annotated.png|600px|left]]
 
[[Image:patharray alignment annotated.png|600px|left]]
 
{{clear}}
 
{{clear}}
{{Caption|Object arranged along a closed path; description of components and path}}
+
{{Caption|Objekt angeordnet entlang einer geschlossenen Bahn; Beschreibung der Komponenten und der Bahn}}
  
The following images show how the array is produced, depending on which plane the path is.
+
Die folgenden Bilder zeigen, wie die Anordnung erzeugt wird, je nachdem, in welcher Ebene die Bahn liegt.
  
 
Bahn in der XY Ebene:
 
Bahn in der XY Ebene:
Line 110: Line 150:
 
Da du den Pfad, aber nicht das Objekt neu orientierst, ist das Ergebnis konsistent: Das Objekt bleibt so am Pfad ausgerichtet, wie es vor der Neuausrichtung des Pfades war.
 
Da du den Pfad, aber nicht das Objekt neu orientierst, ist das Ergebnis konsistent: Das Objekt bleibt so am Pfad ausgerichtet, wie es vor der Neuausrichtung des Pfades war.
  
<div class="mw-translate-fuzzy">
+
{{Emphasis|Editor:}} Vielen Dank an den Benutzer DeepSOIC für diese Erklärung.
{{Emphasis|Editor:}}} Vielen Dank an den Benutzer DeepSOIC für diese Erklärung.
+
 
</div>
+
==Additional alignment modes and options introduced in v0.19==
 +
 
 +
'''Original''' mode (the default) is the historic alignment mode as in version 0.18.
 +
It is not really the Frenet alignment. Original mode uses the normal parameter
 +
from Draft.getNormal (or the default) as a constant - it does not calculate
 +
curve normal. X follows the curve tangent, Y is the normal parameter, Z is
 +
X.Cross(Y).
 +
 
 +
'''Tangent''' mode is similar to '''Original''', but includes a rotation to align the
 +
Base object's X to the TangentVector before placing copies.  After the
 +
rotation, Tangent behaves the same as Original.  In previous versions this
 +
rotation would be performed manually before invoking PathArray.
 +
 
 +
'''Frenet''' mode orients the copies to a coordinate system along the path.  X is
 +
tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not
 +
be computed (ex a straight line), the default is used.
 +
 
 +
The ForceVertical option applies to Original and Tangent modes.  When this
 +
option is applied, the normal parameter from Draft.getNormal is ignored.  X
 +
follows the curve tangent, Z is the VerticalVector property and Y is
 +
X.Cross(Z).
 +
 
 +
Version 18 cycle chain - Original mode
 +
[[Image:patharray_cycleChain.png|600px|left|Align false]]
 +
{{clear}}
 +
 
 +
Railway cross ties (sleepers) - Tangent mode + ForceVertical
 +
[[Image:patharray_railwayTies.png|600px|left|Align false]]
 +
{{clear}}
 +
 
 +
Frenet Modus
 +
[[Image:patharray_FrenetMode.png|600px|left|Align false]]
 +
{{clear}}
  
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}
 
  
{{Draft Tools navi/de}}
+
{{Docnav/de
 +
|[[Draft_LinkArray/de|Verknüpfe Anordnung]]
 +
|[[Draft_PathLinkArray/de|Pfad VerknüpfeAnordnung]]
 +
|[[Draft_Module/de|Entwurf]]
 +
|IconL=Draft_LinkArray.svg
 +
|IconC=Workbench_Draft.svg
 +
|IconR=Draft_PathLinkArray.svg
 +
}}
  
{{Userdocnavi/de}}
+
{{Draft Tools navi{{#translation:}}}}
 +
{{Userdocnavi{{#translation:}}}}
 
{{clear}}
 
{{clear}}

Latest revision as of 12:02, 7 September 2020

Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎română • ‎svenska • ‎čeština • ‎русский

Draft PathArray.svg Entwurf PfadAnordnung

Menüeintrag
Modifikation → Anordnung Werkzeuge → Pfad Anordnung
Arbeitsbereich
Entwurf, Arch
Standardtastenkürzel
None
In der Version eingeführt
0.14
Siehe auch
Entwurf OrthoAnordnung, Entwurf PolarArray, Entwurf CircularArray, Entwurf PfadVerknüpfeAnordnung, Entwurf PunktAnordnung, Entwurf Klonen


Beschreibung

Das Draft PathArray.svg Entwurf PfadAnordnung Werkzeug platziert Kopien einer ausgewählten Form entlang eines ausgewählten Pfades, der ein Entwurf Draht, ein Entwurf BSpline und ähnliche Kanten sein kann.

Das PfadAnordnungswerkzeug kann auf jedes Objekt verwendet werden das eine Part TopoForm hat, bedeutet 2D Formen, die mit dem Entwurf Arbeitsbereich erstellt wurden, aber auch 3D Festkörper, die mit anderen Arbeitsbereichen erstellt wurden, z.B. Part Arbeitsbereich, PartDesign Arbeitsbereich oder Arch Arbeitsbereich.

Draft PathArray Example.png

Objekt entlang eines Pfades angeordnet


Anwendung

  1. Wähle das Objekt aus, das du verteilen möchtest.
  2. Wähle das Pfadobjekt oder die Kanten, entlang derer das Objekt verteilt werden soll.
  3. Drücke die Draft PathArray.svg PfadAnordnung Schaltfläche.
  4. Das Anordnungsobjekt wird sofort erzeugt. Du musst die Eigenschaften der Anordnung ändern, um die Anzahl und Richtung der erstellten Kopien zu ändern.

Jedes Element in der Anordnung ist ein exakter Klon des ursprünglichen Objekts, aber die gesamte Anordnung wird in Bezug auf Eigenschaften und Aussehen als eine Einheit betrachtet.

Hinweis: wenn das DataBasis Objekt nicht korrekt im Pfad positioniert zu sein scheint, prüfe, ob seine DataPlatzierung im Ursprung (0,0,0) liegt. Bestimmte Objekte können überall im 3D Raum platziert werden wenn mit dem Draft PathArray.svg PfadAnordnungs Werkzeug verwendet, jedoch müssen andere am Ursprung sein, insbesondere solche, die unter Verwendung von Part Extrude.svg Part Extrudieren mit einem 2D Profil wie eine Sketcher NewSketch.svg Skizze erstellt wurden.

Optionen

Es gibt keine Optionen für dieses Werkzeug. Entweder funktioniert es mit den ausgewählten Objekten oder nicht.

Eigenschaften

Eine PfadAnordnung wird abgeleitet von einer Part Formelement (Part::Feature Klasse), daher teilt sie alle Eigenschaften der letzteren. Zusätzlich zu den in Part Formelement beschriebenen Eigenschaften hat die PfadAnordnung die folgenden Eigenschaften im Eigenschaftseditor .

Ausrichtung

  • DataAusrichten (Bool): wenn es true ist, werden die Kopien am Pfad ausgerichtet; andernfalls werden sie in ihrer Standardausrichtung belassen.
Hinweis: in bestimmten Fällen wird die Form flach erscheinen, in Wirklichkeit kann sie sich im 3D Raum bewegt haben, ändere also statt einer flachen Ansicht die Ansicht auf axonometrisch.
  • DataAusrichtungsmodus (Aufzählung): drei Modi, Original, Frenet, Tangent.
  • Template:PropertyDataZusätzliche Translation: zusätzlicher Verschiebungsvektor (x, y, z), der auf jede Kopie entlang des Pfades angewendet wird. Dies ist nützlich, um kleine Anpassungen in der Position der Kopien vorzunehmen, z.B. wenn ihr Referenzpunkt nicht mit dem Mittelpunkt ihrer Form übereinstimmt.
  • DataForce Vertical (Bool): Wenn er true ist, wird der Wert von DataVertikal Vektor als lokale Z Richtung verwendet, wenn DataAusrichtungsmodus Original oder Tangente ist. introduced in version 0.19
  • DataTangentenvektor (Vektor): die Standardeinstellung ist (1, 0, 0); Ausrichtungseinheitsvektor, der verwendet wird, wenn DataAusrichtungsmodus Tangente ist. introduced in version 0.19
  • DataVertikal Vektor (Vektor)}: Standardeinstellung ist (0, 0, 1); Einheitsvektor der lokalen Z Richtung, der verwendet wird, wenn DataVertiKal Vektor true ist. introduced in version 0.19

Objects

  • DataBase (LinkGlobal): specifies the object to duplicate in the path.
  • DataCount (Integer): specifies the number of copies to create in the path.
  • DataPath Object (LinkGlobal): specifies the object along which the copies will be distributed. It must contain 'Edges' in its Part TopoShape; for example, it could be a Draft Wire.svg Wire or Draft BSpline.svg BSpline.
  • DataPath Subelements (LinkSubListGlobal): specifies the sub-elements (edges) of the DataPath Object on which the copies will be created. The copies will be created only on these edges. If this property is empty, the copies will be distributed on the entire DataPath Object.

Skripten

Siehe auch: Draft API und FreeCAD Grundlagen Skripten.

Das Pfadanordnungswerkzeug kann in Makros und von der Python Konsole aus mit folgender Funktion verwendet werden:

Alter Aufruf:

path_array = makePathArray(base_object, path_object, count, xlate=None, align=False, pathobjsubs=[])

Neuer Aufruf:

path_array = make_path_array(base_object, path_object,
                             count=4, extra=App.Vector(0, 0, 0), subelements=None,
                             align=False, align_mode="Original", tan_vector=App.Vector(1, 0, 0),
                             force_vertical=False, vertical_vector=App.Vector(0, 0, 1),
                             use_link=True):
  • Erstellt eine Pfad Anordnungs Objekt aus dem baseobject, indem bis zu Anzahl Kopien entlang des Template:Incode/de platziert werden.
  • Wenn xlate angegeben wird, handelt es sich um einen FreeCAD.Vector, der eine zusätzliche Verschiebung anzeigt, um den Basispunkt der Kopien zu verschieben.
  • Wenn align True ist, werden die Kopien an der Tangente, der Normalen oder dem Binormalen des Template:Incode/de an dem Punkt ausgerichtet, an dem die Kopie platziert wird.

Beispiel:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(500, -1000, 0)
p2 = App.Vector(1500, 1000, 0)
p3 = App.Vector(3000, 500, 0)
p4 = App.Vector(4500, 100, 0)
spline = Draft.make_bspline([p1, p2, p3, p4])
obj = Draft.make_polygon(3, 500)

path_array = Draft.make_path_array(obj, spline, 6)
doc.recompute()

wire = Draft.make_wire([p1, -p2, -p3, -p4])
path_array2 = Draft.make_path_array(obj, wire, count=3, extra=App.Vector(0, -500, 0), subelements=["Edge2", "Edge3"], align=True, force_vertical=True)
doc.recompute()

Technische Erklärung für die Ausrichteigenschaft

Wenn DataAusrichten false ist, ist die Platzierung der kopierten Formen leicht zu verstehen; sie werden einfach an eine andere Position in ihrer ursprünglichen Ausrichtung verschoben.

Align false

Objekt, das entlang eines geschlossenen Pfades in der ursprünglichen Ausrichtung angeordnet ist.


Wenn DataAlign true ist, wird die Positionierung der Formen etwas komplexer:

  1. Zuerst werden Frenet Koordinatensysteme auf dem Pfad aufgebaut: X ist tangential, Z ist normal, Y ist binormal.
  2. Dann wird das Originalobjekt in jedes pfadbegleitende Koordinatensystem kopiert, so dass der globale Ursprung mit dem Ursprung des pfadbegleitenden Koordinatensystems übereinstimmt.
Patharray alignment annotated.png

Objekt angeordnet entlang einer geschlossenen Bahn; Beschreibung der Komponenten und der Bahn


Die folgenden Bilder zeigen, wie die Anordnung erzeugt wird, je nachdem, in welcher Ebene die Bahn liegt.

Bahn in der XY Ebene:

Patharray alignment.png

Objekt, angeordnet entlang einer geschlossenen Bahn, die auf die XY Ebene ausgerichtet ist


Pfad in der XZ Ebene:

Patharray alignment-XZ.png

Objekt angeordnet entlang einer geschlossenen Bahn, die auf die XZ Ebene ausgerichtet ist


Pfad in der YZ Ebene:

Patharray alignment-YZ.png

Objekt angeordnet entlang eines geschlossenen Pfades, der auf die YZ Ebene ausgerichtet ist


Da du den Pfad, aber nicht das Objekt neu orientierst, ist das Ergebnis konsistent: Das Objekt bleibt so am Pfad ausgerichtet, wie es vor der Neuausrichtung des Pfades war.

Editor: Vielen Dank an den Benutzer DeepSOIC für diese Erklärung.

Additional alignment modes and options introduced in v0.19

Original mode (the default) is the historic alignment mode as in version 0.18. It is not really the Frenet alignment. Original mode uses the normal parameter from Draft.getNormal (or the default) as a constant - it does not calculate curve normal. X follows the curve tangent, Y is the normal parameter, Z is X.Cross(Y).

Tangent mode is similar to Original, but includes a rotation to align the Base object's X to the TangentVector before placing copies. After the rotation, Tangent behaves the same as Original. In previous versions this rotation would be performed manually before invoking PathArray.

Frenet mode orients the copies to a coordinate system along the path. X is tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not be computed (ex a straight line), the default is used.

The ForceVertical option applies to Original and Tangent modes. When this option is applied, the normal parameter from Draft.getNormal is ignored. X follows the curve tangent, Z is the VerticalVector property and Y is X.Cross(Z).

Version 18 cycle chain - Original mode

Align false


Railway cross ties (sleepers) - Tangent mode + ForceVertical

Align false


Frenet Modus

Align false